#ifndef SDK2X_SD_HW_H
#define SDK2X_SD_HW_H

/* **************************************************************************
 *    Copyright (C) 2005 by Rob Brown                                       *
 *    rob@cobbleware.com                                                    *
 *                                                                          *
 *    C Header: sdk2x_sd_hw                                                 *
 *                                                                          *
 *    This program is free software; you can redistribute it and/or modify  *
 *    it under the terms of the GNU General Public License as published by  *
 *    the Free Software Foundation; either version 2 of the License, or     *
 *    (at your option) any later version.                                   *
 *                                                                          *
 *    This program is distributed in the hope that it will be useful,       *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *    GNU General Public License for more details.                          *
 *                                                                          *
 *    You should have received a copy of the GNU General Public License     *
 *    along with this program; if not, write to the                         *
 *    Free Software Foundation, Inc.,                                       *
 *    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 * **************************************************************************/

#define SDK2X_ERR_SDHW_OK								(0)
#define SDK2X_ERR_SDHW_TOO_MANY_ITERATIONS		(1)
#define SDK2X_ERR_SDHW_TIMEOUT						(2)
#define SDK2X_ERR_SDHW_CRC								(3)
#define SDK2X_ERR_SDHW_GET_ID							(4)
#define SDK2X_ERR_SDHW_RW_MISMATCH					(5)
#define SDK2X_ERR_SDHW_GET_CSD						(6)
#define SDK2X_ERR_SDHW_CARD_SELECT					(7)
#define SDK2X_ERR_SDHW_SET_BLOCK_SIZE				(8)
#define SDK2X_ERR_SDHW_ACMD_4BIT_COMMS				(9)
#define SDK2X_ERR_SDHW_4BIT_COMMS					(10)
#define SDK2X_ERR_SDHW_PARAMETER						(11)
#define SDK2X_ERR_SDHW_READ_MULTIPLE				(12)
#define SDK2X_ERR_SDHW_READ_MULTIPLE_STOP			(13)
#define SDK2X_ERR_SDHW_NOT_READY						(14)
#define SDK2X_ERR_SDHW_WRITE_MULTIPLE				(15)
#define SDK2X_ERR_SDHW_WRITE_MULTIPLE_STOP		(16)
#define SDK2X_ERR_SDHW_ACMD_PRE_ERASE				(17)
#define SDK2X_ERR_SDHW_PRE_ERASE						(18)
#define SDK2X_ERR_SDHW_FIFO_TIMEOUT					(19)
#define SDK2X_ERR_SDHW_TRANSFER_ERROR				(20)
#define SDK2X_ERR_SDHW_TRANSFER_ERROR2				(21)

int sdk2x_SdHwInit (void);
int sdk2x_SdHwDeselectCard (void);
int sdk2x_SdHwSelectCard (void);
int sdk2x_SdReadSectors (unsigned int address, void *dest, unsigned short numblocks);
int sdk2x_SdWriteSectors (unsigned int address, void *source, unsigned short numblocks);

#endif /* SDK2X_SD_HW_H */

